program pagescript;
begin
  // calculate a base RPM derived from current coolant temperature.
  // clt values are raw i.e. without the delta subtracted.
  if (clt < 90) then	// 50c
    cltshiftlightrpm := shiftlightbase - 1000
  else
  if (clt < 116) then    // 76c
    cltshiftlightrpm := shiftlightbase - (115 - clt) * 40
  else
    cltshiftlightrpm := shiftlightbase;

  // now populate a bitmap for each of the 6 shift lights.
  if (rpm > cltshiftlightrpm) then
    shiftbits := shiftbits or 1
  else
    shiftbits := shiftbits and 254;

  if (rpm > cltshiftlightrpm+250) then
    shiftbits := shiftbits or 2
  else
    shiftbits := shiftbits and 253;

  if (rpm > cltshiftlightrpm+500) then
    shiftbits := shiftbits or 4
  else
    shiftbits := shiftbits and 251;

  if (rpm > cltshiftlightrpm+750) then
    shiftbits := shiftbits or 8
  else
    shiftbits := shiftbits and 247;

  if (rpm > cltshiftlightrpm+1000) then
    shiftbits := shiftbits or 16
  else
    shiftbits := shiftbits and 239;

  if (rpm > cltshiftlightrpm+1250) then
    shiftbits := shiftbits or 32
  else
    shiftbits := shiftbits and 223;
end.
